<!DOCTYPE html>
<html>
<head>
  <script src="dist/face-api.js"></script>
  <script src="js/commons.js"></script>
  <script src="js/faceDetectionControls.js"></script>
  <link rel="stylesheet" href="styles.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/0.100.2/css/materialize.css">
  <script type="text/javascript" src="https://code.jquery.com/jquery-2.1.1.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/0.100.2/js/materialize.min.js"></script>
</head>
<body>
<div id="navbar"></div>
<div class="center-content page-container">

  <div class="progress" id="loader">
    <div class="indeterminate"></div>
  </div>
  <div style="position: relative" class="margin">
    <video onloadedmetadata="onPlay(this)" id="inputVideo" autoplay muted playsinline></video>
    <canvas id="overlay" />
  </div>

  <div class="row side-by-side">

    <!-- face_detector_selection_control -->
    <div id="face_detector_selection_control" class="row input-field" style="margin-right: 20px;">
      <select id="selectFaceDetector">
        <option value="ssd_mobilenetv1">SSD Mobilenet V1</option>
        <option value="tiny_face_detector">Tiny Face Detector</option>
      </select>
      <label>Select Face Detector</label>
    </div>
    <!-- face_detector_selection_control -->

    <!-- fps_meter -->
    <div id="fps_meter" class="row side-by-side">
      <div>
        <label for="time">Time:</label>
        <input disabled value="-" id="time" type="text" class="bold">
        <label for="fps">Estimated Fps:</label>
        <input disabled value="-" id="fps" type="text" class="bold">
      </div>
    </div>
    <!-- fps_meter -->

  </div>


  <!-- ssd_mobilenetv1_controls -->
  <span id="ssd_mobilenetv1_controls">
      <div class="row side-by-side">
        <div class="row">
          <label for="minConfidence">Min Confidence:</label>
          <input disabled value="0.5" id="minConfidence" type="text" class="bold">
        </div>
        <button
                class="waves-effect waves-light btn"
                onclick="onDecreaseMinConfidence()"
        >
          <i class="material-icons left">-</i>
        </button>
        <button
                class="waves-effect waves-light btn"
                onclick="onIncreaseMinConfidence()"
        >
          <i class="material-icons left">+</i>
        </button>
      </div>
    </span>
  <!-- ssd_mobilenetv1_controls -->

  <!-- tiny_face_detector_controls -->
  <span id="tiny_face_detector_controls">
      <div class="row side-by-side">
        <div class="row input-field" style="margin-right: 20px;">
          <select id="inputSize">
            <option value="" disabled selected>Input Size:</option>
            <option value="128">128 x 128</option>
            <option value="160">160 x 160</option>
            <option value="224">224 x 224</option>
            <option value="320">320 x 320</option>
            <option value="416">416 x 416</option>
            <option value="512">512 x 512</option>
            <option value="608">608 x 608</option>
          </select>
          <label>Input Size</label>
        </div>
        <div class="row">
          <label for="scoreThreshold">Score Threshold:</label>
          <input disabled value="0.5" id="scoreThreshold" type="text" class="bold">
        </div>
        <button
                class="waves-effect waves-light btn"
                onclick="onDecreaseScoreThreshold()"
        >
          <i class="material-icons left">-</i>
        </button>
        <button
                class="waves-effect waves-light btn"
                onclick="onIncreaseScoreThreshold()"
        >
          <i class="material-icons left">+</i>
        </button>
      </div>
    </span>
  <!-- tiny_face_detector_controls -->

</body>

<script>
  let forwardTimes = []

  function updateTimeStats(timeInMs) {
    forwardTimes = [timeInMs].concat(forwardTimes).slice(0, 30)
    const avgTimeInMs = forwardTimes.reduce((total, t) => total + t) / forwardTimes.length
    $('#time').val(`${Math.round(avgTimeInMs)} ms`)
    $('#fps').val(`${faceapi.utils.round(1000 / avgTimeInMs)}`)
  }

  async function onPlay() {
    const videoEl = $('#inputVideo').get(0)

    if(videoEl.paused || videoEl.ended || !isFaceDetectionModelLoaded())
      return setTimeout(() => onPlay())


    const options = getFaceDetectorOptions()

    const ts = Date.now()

    const result = await faceapi.detectSingleFace(videoEl, options)

    updateTimeStats(Date.now() - ts)

    if (result) {
      const canvas = $('#overlay').get(0)
      const dims = faceapi.matchDimensions(canvas, videoEl, true)
      faceapi.draw.drawDetections(canvas, faceapi.resizeResults(result, dims))
    }

    setTimeout(() => onPlay())
  }

  async function run() {
    // load face detection model
    await changeFaceDetector(TINY_FACE_DETECTOR)
    changeInputSize(128)

    // try to access users webcam and stream the images
    // to the video element
    const stream = await navigator.mediaDevices.getUserMedia({ video: {} })
    const videoEl = $('#inputVideo').get(0)
    videoEl.srcObject = stream
  }

  function updateResults() {}

  $(document).ready(function() {
    renderNavBar('#navbar', 'webcam_face_detection')
    initFaceDetectionControls()
    run()
  })
</script>
</body>
</html>